# coding: utf-8

"""
    mzTab-M reference implementation and validation API.

    This is the mzTab-M reference implementation and validation API service.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: nils.hoffmann@isas.de
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from openapi_client.configuration import Configuration


class StudyVariable(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'assay_refs': 'list[Assay]',
        'average_function': 'Parameter',
        'variation_function': 'Parameter',
        'description': 'str',
        'factors': 'list[Parameter]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'assay_refs': 'assay_refs',
        'average_function': 'average_function',
        'variation_function': 'variation_function',
        'description': 'description',
        'factors': 'factors'
    }

    def __init__(self, id=None, name=None, assay_refs=None, average_function=None, variation_function=None, description=None, factors=None, local_vars_configuration=None):  # noqa: E501
        """StudyVariable - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._assay_refs = None
        self._average_function = None
        self._variation_function = None
        self._description = None
        self._factors = None
        self.discriminator = None

        self.id = id
        self.name = name
        if assay_refs is not None:
            self.assay_refs = assay_refs
        if average_function is not None:
            self.average_function = average_function
        if variation_function is not None:
            self.variation_function = variation_function
        if description is not None:
            self.description = description
        if factors is not None:
            self.factors = factors

    @property
    def id(self):
        """Gets the id of this StudyVariable.  # noqa: E501


        :return: The id of this StudyVariable.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this StudyVariable.


        :param id: The id of this StudyVariable.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                id is not None and id < 1):  # noqa: E501
            raise ValueError("Invalid value for `id`, must be a value greater than or equal to `1`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this StudyVariable.  # noqa: E501

        The study variable name.  # noqa: E501

        :return: The name of this StudyVariable.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this StudyVariable.

        The study variable name.  # noqa: E501

        :param name: The name of this StudyVariable.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def assay_refs(self):
        """Gets the assay_refs of this StudyVariable.  # noqa: E501

        The assays referenced by this study variable.  # noqa: E501

        :return: The assay_refs of this StudyVariable.  # noqa: E501
        :rtype: list[Assay]
        """
        return self._assay_refs

    @assay_refs.setter
    def assay_refs(self, assay_refs):
        """Sets the assay_refs of this StudyVariable.

        The assays referenced by this study variable.  # noqa: E501

        :param assay_refs: The assay_refs of this StudyVariable.  # noqa: E501
        :type: list[Assay]
        """

        self._assay_refs = assay_refs

    @property
    def average_function(self):
        """Gets the average_function of this StudyVariable.  # noqa: E501


        :return: The average_function of this StudyVariable.  # noqa: E501
        :rtype: Parameter
        """
        return self._average_function

    @average_function.setter
    def average_function(self, average_function):
        """Sets the average_function of this StudyVariable.


        :param average_function: The average_function of this StudyVariable.  # noqa: E501
        :type: Parameter
        """

        self._average_function = average_function

    @property
    def variation_function(self):
        """Gets the variation_function of this StudyVariable.  # noqa: E501


        :return: The variation_function of this StudyVariable.  # noqa: E501
        :rtype: Parameter
        """
        return self._variation_function

    @variation_function.setter
    def variation_function(self, variation_function):
        """Sets the variation_function of this StudyVariable.


        :param variation_function: The variation_function of this StudyVariable.  # noqa: E501
        :type: Parameter
        """

        self._variation_function = variation_function

    @property
    def description(self):
        """Gets the description of this StudyVariable.  # noqa: E501

        A free-form description of this study variable.  # noqa: E501

        :return: The description of this StudyVariable.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this StudyVariable.

        A free-form description of this study variable.  # noqa: E501

        :param description: The description of this StudyVariable.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def factors(self):
        """Gets the factors of this StudyVariable.  # noqa: E501

        Parameters indicating which factors were used for the assays referenced by this study variable, and at which levels.  # noqa: E501

        :return: The factors of this StudyVariable.  # noqa: E501
        :rtype: list[Parameter]
        """
        return self._factors

    @factors.setter
    def factors(self, factors):
        """Sets the factors of this StudyVariable.

        Parameters indicating which factors were used for the assays referenced by this study variable, and at which levels.  # noqa: E501

        :param factors: The factors of this StudyVariable.  # noqa: E501
        :type: list[Parameter]
        """

        self._factors = factors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StudyVariable):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StudyVariable):
            return True

        return self.to_dict() != other.to_dict()
